//*****************************************************************************
// File Name            : hello_world_small.c
//-----------------------------------------------------------------------------
// Function             : OpenCores IP PWM
//
//-----------------------------------------------------------------------------
// Designer             : yokomizo
//-----------------------------------------------------------------------------
// History
// -.-- 2013/03/29
//*****************************************************************************

#ifdef __hal__
  #include "sys/alt_stdio.h"
  #include "system.h" 
  // BASEADDR
  #define PWM0_BASEADDR   0x50000000
  #define PWM1_BASEADDR   0x50000010
  // PRINT macro 
  #define M_PRINT(str)  alt_putstr(str);
#elif __microblaze__
  #include <stdio.h>
  #include "platform.h"
  #include "xbasic_types.h"
  #include "XIOModule.h"
  // BASEADDR
  #define PWM0_BASEADDR   0xD0000000
  #define PWM1_BASEADDR   0xD0000010
  // PRINT macro 
  #define M_PRINT(str)  print(str);
#endif

#define GPO      (*(volatile unsigned int *) PIO_0_BASE)
#define PWM0_CTRL (*(volatile unsigned short int *) (PWM0_BASEADDR + 0x0))
#define PWM0_DIV  (*(volatile unsigned short int *) (PWM0_BASEADDR + 0x2))
#define PWM0_PERIOD (*(volatile unsigned short int *) (PWM0_BASEADDR + 0x4))
#define PWM0_DC (*(volatile unsigned short int *) (PWM0_BASEADDR + 0x6))

#define PWM1_CTRL (*(volatile unsigned short int *) (PWM1_BASEADDR + 0x0))
#define PWM1_DIV  (*(volatile unsigned short int *) (PWM1_BASEADDR + 0x2))
#define PWM1_PERIOD (*(volatile unsigned short int *) (PWM1_BASEADDR + 0x4))
#define PWM1_DC (*(volatile unsigned short int *) (PWM1_BASEADDR + 0x6))

int main()
{ 
  //PWM0 10uS Duty Hi:50% Low:50%
  PWM0_DIV = 100;
  PWM0_PERIOD = 100;
  PWM0_DC =      50;
  //PWM1 100uS Duty Hi:5% Low:95%
  PWM1_DIV = 100;
  PWM1_PERIOD = 100;
  PWM1_DC =       5;
  //PWM start
  PWM0_CTRL = 0x1e;     //start
  PWM1_CTRL = 0x1e;     //start
  M_PRINT("Hello World \n");
  /* Event loop never exits. */
  while (1);

  return 0;
}

